<template>
  <dibs-layout
    ref="layout"
    page="avs"
    layout="two-columns"
    :video="video"
    class="dibs--avs"
  >
    <template #aside-header
      ><div />
      <dibs-elem-lang-dropdown
    /></template>
    <template #aside-title>
      <!-- eslint-disable-next-line vue/no-v-html -->
      <h1 v-html="$t('page.avs.title')" />
    </template>
    <template #content>
      <dibs-modal ref="modal-avs">
        <template #title>{{ $t('page.avs.modal.title') }}</template>
        <template #content>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <p v-html="$t('page.avs.modal.content')" />
          <br />
          <dibs-img file="hints/avs1.png" />
          <dibs-img file="hints/avs2.png" />
        </template>
      </dibs-modal>
      <pre v-if="mode == 'debug'">{{
        { form, relationshipForm, childForm }
      }}</pre>
      <template v-if="init">
        <dibs-form-elem
          :label="$t('page.avs.form.labels.avs')"
          :info="$t('page.avs.form.labels.avs_info')"
          name="navs"
        >
          <dibs-form-row :element-count="2">
            <dibs-input-avs
              id="navs"
              :default="form.navs"
              @input="changeNavs"
            />
            <template v-if="isLoadingAvs">
              <div style="position: relative; height: 100%; width: 50px">
                <loading
                  :active.sync="isLoadingAvs"
                  :is-full-page="false"
                  color="var(--dibs-colors--red)"
                  :height="25"
                />
              </div>
            </template>
            <template v-else>
              <dibs-input-help
                v-if="!currentInsured"
                @click="$refs['modal-avs'].open()"
              >
                {{ $t('commons.where_to_find') }}
              </dibs-input-help>
              <dl v-if="currentInsured" class="dibs-synthesis--aside--data">
                <dt>{{ $t('page.avs.form.labels.birthdate') }}</dt>
                <dd>
                  {{ form.birthDate }}
                </dd>
                <dt>{{ $t('page.avs.form.labels.gender') }}</dt>
                <dd>
                  {{ $t(`commons.gender.${form.sex}`) }}
                </dd>
              </dl>
            </template>
          </dibs-form-row>
        </dibs-form-elem>
        <template v-if="currentInsured">
          <dibs-form-elem
            :label="$t('page.avs.form.labels.status')"
            name="relationshipType"
          >
            <dibs-form-row>
              <dibs-input-radios
                id="relationshipType"
                v-model="relationshipType"
                :default="relationshipType"
                :options="[
                  {
                    label: $t('commons.status.bachelor.neutral'),
                    value: relationTypes.bachelor,
                  },
                  {
                    label: $t('commons.status.married.neutral'),
                    value: relationTypes.spouse,
                  },
                  {
                    label: $t('commons.status.divorced.neutral'),
                    value: relationTypes.divorced,
                  },
                  {
                    label: $t('commons.status.remarried.neutral'),
                    value: relationTypes.remarried,
                  },
                  {
                    label: $t('commons.status.widow.neutral'),
                    value: relationTypes.widowed,
                  },
                ]"
              />
            </dibs-form-row>
          </dibs-form-elem>

          <template v-if="relationshipType != relationTypes.bachelor">
            <dibs-utils-metabox v-if="relationshipType != relationTypes.spouse">
              <!-- eslint-disable-next-line vue/no-v-html -->
              <p v-html="$t('page.avs.warning.body')" />
            </dibs-utils-metabox>

            <dibs-form-elem
              v-if="relationshipType == relationTypes.spouse"
              :label="$t('page.avs.form.labels.partner_avs')"
              name="partnaireAvs"
              :info="$t('page.avs.form.labels.avs_info')"
            >
              <dibs-form-row :element-count="2">
                <dibs-input-avs
                  id="partnaireAvs"
                  :default="relationshipForm.person.navs"
                  @input="changePartnerNavs"
                />

                <template v-if="isLoadingPartnerAvs">
                  <div style="position: relative; height: 100%; width: 50px">
                    <loading
                      :active.sync="isLoadingPartnerAvs"
                      :is-full-page="false"
                      color="var(--dibs-colors--red)"
                      :height="25"
                    />
                  </div>
                </template>
                <template v-else>
                  <dibs-input-help
                    v-if="!partnerInsured"
                    @click="$refs['modal-avs'].open()"
                  >
                    {{ $t('commons.where_to_find') }}
                  </dibs-input-help>
                  <dl v-if="partnerInsured" class="dibs-synthesis--aside--data">
                    <dt>{{ $t('page.avs.form.labels.partner_birth') }}</dt>
                    <dd>
                      {{ relationshipForm.person.birthDate }}
                    </dd>
                    <dt>{{ $t('page.avs.form.labels.partner_gender') }}</dt>
                    <dd>
                      {{ $t(`commons.gender.${relationshipForm.person.sex}`) }}
                    </dd>
                  </dl>
                </template>
              </dibs-form-row>
            </dibs-form-elem>

            <dibs-form-row :key="'form-' + relationshipType" :element-count="2">
              <dibs-form-elem
                hint="11.02.2010"
                :label="$t('page.avs.form.labels.relationship_start')"
              >
                <dibs-input-date
                  id="start"
                  v-model="relationshipForm.start"
                  name="start"
                  :default="relationshipForm.start"
                />
              </dibs-form-elem>
            </dibs-form-row>
          </template>
          <dibs-form-row :element-count="2">
            <dibs-form-elem
              :label="$t('page.avs.form.labels.child_count')"
              name="childCount"
            >
              <dibs-input-select
                id="childCount"
                :default="childCount"
                :options="[0, 1, 2, 3, 4, 5, 6]"
                @input="childCount = Number($event)"
              />
            </dibs-form-elem>
          </dibs-form-row>
          <template v-for="(child, i) in childForm">
            <dibs-form-elem
              :key="'child-' + childCount + '-' + i"
              hint="10.09.2017"
              :label="$t('page.avs.form.labels.child_birth') + ' ' + (i + 1)"
              :name="'childBirthDate' + i"
            >
              <dibs-form-row :element-count="2">
                <dibs-input-date
                  :id="'childBirthDate' + i"
                  :default="childForm[i].birthDate"
                  @input="
                    $set(
                      childForm,
                      i,
                      Object.assign(childForm[i], { birthDate: $event })
                    )
                  "
                />
                <dibs-input-checkbox
                  :checked="childForm[i].isAlive"
                  @input="
                    $set(
                      childForm,
                      i,
                      Object.assign(childForm[i], { isAlive: $event })
                    )
                  "
                  >{{
                    $t('page.avs.form.labels.child_is_alive')
                  }}</dibs-input-checkbox
                >
              </dibs-form-row>
              <dibs-form-row v-if="!childForm[i].isAlive" :element-count="2">
                <dibs-form-elem
                  :label="
                    $t('page.avs.form.labels.child_death') + ' ' + (i + 1)
                  "
                  :name="'childDeathDate' + i"
                >
                  <dibs-input-date
                    :id="'childDeathDate' + i"
                    :default="childForm[i].deathDate"
                    @input="
                      $set(
                        childForm,
                        i,
                        Object.assign(childForm[i], { deathDate: $event })
                      )
                    "
                  />
                </dibs-form-elem>
              </dibs-form-row>
            </dibs-form-elem>
          </template>
        </template>

        <dibs-elem-btn
          :label="$t('page.avs.action')"
          picto="forward"
          :disabled="!formIsOk"
          @click="onSave"
        />
        <!-- <router-link to="#" class="dibs-page-avs-cannot"
          >je n'ai pas réussi à me connecter</router-link
        > -->
      </template>
    </template>
  </dibs-layout>
</template>

<script>
import _ from 'lodash'
import Loading from 'vue-loading-overlay'

export default {
  name: 'IndexPage',
  components: { Loading },
  layout: 'dibs',
  data() {
    return {
      isLoadingAvs: false,
      isLoadingPartnerAvs: false,
      video: this.$t('page.avs.video'),
      relationTypes: {
        bachelor: null,
        spouse: 'SPOUSE',
        divorced: 'DIVORCED',
        widowed: 'WIDOWED',
        remarried: 'REMARRIED',
      },
      init: false,
      mode: this.$route.query.mode,
      relationshipType: null,
      childFormTemplate: {
        birthDate: null,
        isAlive: true,
        deathDate: null,
      },
      childForm: [],
      childCount: 0,
      partnerFormTemplate: {
        navs: null,
        birthDate: null,
        deathDate: null,
        nationality: 100,
        residency: 100,
        sex: 'MALE',
      },
      relationshipForm: {
        start: null,
        end: null,
        type: null,
        person: [],
      },
      form: {
        navs: null,
        birthDate: null,
        sex: 'FEMALE',
      },
      currentInsured: null,
      partnerInsured: null,
    }
  },
  computed: {
    formIsOk() {
      if (!this.currentInsured) return false
      if (!this.form.navs || !this.form.birthDate) return false
      if (
        this.relationshipForm.type === this.relationTypes.spouse &&
        (!this.partnerInsured ||
          !this.relationshipForm.start ||
          !this.relationshipForm.person.navs ||
          !this.relationshipForm.person.birthDate)
      )
        return false

      return true
    },
  },
  watch: {
    relationshipType(type, oldType) {
      this.relationshipForm.type = type
      if (!type) {
        this.relationshipForm.person = null
      } else if (type && !oldType && _.isEmpty(this.relationshipForm.person)) {
        this.relationshipForm.person = Object.assign(
          {},
          this.partnerFormTemplate
        )
      }
    },
    childCount(childCount) {
      if (childCount === 0) {
        this.childForm = []
      } else {
        for (let i = 0; i < childCount; i++) {
          if (!this.childForm[i]) {
            this.childForm[i] = Object.assign({}, this.childFormTemplate)
          }
        }
      }
      if (this.childForm.length > childCount) {
        this.childForm.splice(childCount)
      }
    },
  },
  mounted() {
    this.$models.Loader().on()
    this.$models.User().checkConnectionStatus()
    this.$models
      .OpenAK()
      .getInfo()
      .then((form) => {
        this._populateFormFromOpenAkInfo(form)
        this.init = true
      })
      .catch(() => {
        this.init = true
      })
      .finally(() => {
        this.$models.Loader().off()
      })
  },
  methods: {
    error() {
      alert(
        "Une erreur est survenue lors de l'estimation de votre rente de vieillesse étatique: êtes-vous sûr des données fournies ?"
      )
    },
    onSave() {
      this.$models.Loader().on()

      const form = this._createOpenAKInfoFromForm()
      this.$models
        .OpenAK()
        .saveInfo(form)
        .then(() => {
          this.$models
            .OpenAK()
            .get()
            .then((pension) => {
              if (pension.originalPension) {
                this.$router.push(this.localePath('/synthesis'))
              } else {
                this.error()
              }
            })
            .catch(() => {
              this.error()
            })
            .finally(() => {
              this.$models.Loader().off()
            })
        })
        .catch(() => {
          this.$refs.layout.loadMe(true)
        })
    },
    _populateFormFromOpenAkInfo(info) {
      const relationships = info.relationships
      delete info.relationships
      info = this._unfilterArrayOrObject(info)
      this.form = info
      this.changeNavs(this.form.navs)

      const children = []
      _.forEach(relationships, (relation) => {
        if (relation.type === 'CHILDREN') {
          children.push(relation)
        } else {
          this.relationshipType = relation.type
          this.relationshipForm = this._unfilterArrayOrObject(relation)
          this.relationshipForm.person = this._unfilterArrayOrObject(
            relation.person
          )
          this.changePartnerNavs(this.relationshipForm.person.navs)
        }
      })

      this.childCount = children.length
      _.forEach(children, (child, id) => {
        this.childForm[id] = this._unfilterArrayOrObject(child.person)
        this.childForm[id].isAlive = !this.childForm[id].deathDate
      })
    },
    _unfilterArrayOrObject(untransformed) {
      const transformed = Object.assign({}, untransformed)
      // if (filtered.navs) {
      //   filtered.navs = filtered.navs.replace(/\./g, '')
      // }

      // filtered = _.omit(
      //   _.pickBy(filtered, (v) => v !== null),
      //   ['isAlive']
      // )

      _.forEach(
        _.pick(transformed, ['start', 'end', 'birthDate', 'deathDate']),
        (date, id) => {
          transformed[id] = date.split('-').reverse().join('.')
        }
      )

      return transformed
    },
    _createOpenAKInfoFromForm() {
      let form = Object.assign({}, this.form)
      form = this._filterArrayOrObject(form)

      if (!this.relationshipForm.type) {
        form.relationships = []
      } else {
        let relationships = Object.assign({}, this.relationshipForm)
        relationships = this._filterArrayOrObject(relationships)
        relationships.person = this._filterArrayOrObject(relationships.person)
        form.relationships = [relationships]
      }

      // form.relationships = JSON.stringify(
      form.relationships = form.relationships.concat(
        Object.values(
          this._filterArrayOrObject(
            this.childForm.map(this._filterArrayOrObject).map((child) => {
              return {
                type: 'CHILDREN',
                person: child,
              }
            })
          )
        )
      )

      return form
    },
    _filterArrayOrObject(toBeFiltered) {
      let filtered = Object.assign({}, toBeFiltered)
      if (filtered.navs) {
        filtered.navs = filtered.navs.replace(/\./g, '')
      }

      filtered = _.omit(
        _.pickBy(filtered, (v) => v !== null),
        ['isAlive']
      )

      _.forEach(
        _.pick(filtered, ['start', 'end', 'birthDate', 'deathDate']),
        (date, id) => {
          filtered[id] = date.split('.').reverse().join('-')
        }
      )

      return filtered
    },
    changeNavs(navs) {
      this.currentInsured = null
      this.isLoadingAvs = true
      this.$models
        .OpenAK()
        .getInsuredInfo(navs)
        .then((insured) => {
          this.currentInsured = insured
          this.form.navs = navs
          this.form.birthDate = insured.birthdate.split('-').reverse().join('.')
          this.form.sex = insured.gender === 1 ? 'MALE' : 'FEMALE'
        })
        .catch(() => {})
        .finally(() => {
          this.isLoadingAvs = false
        })
    },
    changePartnerNavs(navs) {
      this.partnerInsured = null
      this.isLoadingPartnerAvs = true
      this.$models
        .OpenAK()
        .getInsuredInfo(navs)
        .then((insured) => {
          this.partnerInsured = insured
          this.relationshipForm.person.navs = navs
          this.relationshipForm.person.birthDate = insured.birthdate
            .split('-')
            .reverse()
            .join('.')
          this.relationshipForm.person.sex =
            insured.gender === 1 ? 'MALE' : 'FEMALE'
        })
        .catch(() => {})
        .finally(() => {
          this.isLoadingPartnerAvs = false
        })
    },
  },
}
</script>
<style>
.dibs-page-avs-cannot {
  display: block;
  text-align: center;
  margin-top: 2em;
}
</style>
